#define _GNU_SOURCE 1
#include <dlfcn.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

void _intercept_init(void) __attribute__ ((constructor));
void _intercept_fini(void) __attribute__ ((destructor));

static void *libhandle = NULL;
static int (*real_testf)(const char *pathname)=NULL;

void _intercept_init(void)
{
   printf("_intercept_init\n");
#ifdef RTLD_NEXT
#warning RTLD_NEXT
      libhandle = RTLD_NEXT;
#else
      libhandle = dlopen("libtestf.so",RTLD_LAZY);
#endif   
      real_testf = dlsym(libhandle,"testf");
      printf("libhandle=%p real=%p\n",libhandle,real_testf);
}

void _intercept_fini(void)
{
   printf("_intercept_fini\n");
}


int testf(const char *name)
{
   int ret=0;
   printf("intercept testf(%s)\n",name);
   if(real_testf!=NULL)
   {
      printf("\taufruf echte testf\n");
      ret = (*real_testf)(name); 
      ret++;
   } 
   else
   {
      printf("\tkeine echte testf gefunden \n");
      return -2;
   }
   printf("intercept - ende\n");
   return ret;
}
